:- [util].

% starte_bietphase
% Startet einen neuen Bietphasenzyklus
% Dabei verwendet die alte Zugreihenfolge als Bietreihenfolge
% Setzt die neue Zugreihenfolge nach Auswertung des Bietendes
starte_bietphase :-
        spielfeld(X),
	starte_bietphase(X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)),
	ueberpruefe_bot.

starte_bietphase(SpielfeldAnfang,Spielfeld) :-
	not(member(gewinner(_),SpielfeldAnfang)),
	member(zugreihenfolge(SpielerListe),SpielfeldAnfang),
	non_unifying_delete(SpielfeldAnfang,
			    aktuelles_gebot(_,_),
			    SpielfeldAnfang2),

	% Ueberprueft, ob Spieler noch Chips haben
	% und gibt ihnen wieder welche, falls nicht
	(member(noch_vorhandener_chip(_,_),SpielfeldAnfang2) ->
	 SpielfeldEnde = SpielfeldAnfang2;
	 reset_chips_liste(SpielerListe,SpielfeldAnfang2,SpielfeldEnde)),

	append([bietphase(SpielerListe)],SpielfeldEnde,Spielfeld).

% gebot_eingeben(+SpielerID,+Gebot)
% Gibt fuer eine Person ein Gebot ab, falls moeglich
gebot_eingeben(Zahl) :-
	spielfeld(X),
	gebot_eingeben(Zahl,X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)),
	ueberpruefe_bot.

gebot_eingeben(Zahl,SpielfeldAnfang,Spielfeld) :-
    % Vorbedingungen
	member(bietphase([Spieler|R]),SpielfeldAnfang),
	aktueller_spieler(Spieler,SpielfeldAnfang),
	kann_bieten(Spieler,Zahl,SpielfeldAnfang),
	append([aktuelles_gebot(Spieler, Zahl)],
	       SpielfeldAnfang,
	       SpielfeldAnfang2),
	select(noch_vorhandener_chip(Spieler, Zahl),
	       SpielfeldAnfang2,
	       SpielfeldEnde),
	select(bietphase(_),SpielfeldEnde,SpielfeldEnde2),
	append([bietphase(R)],SpielfeldEnde2,SpielfeldEnde3),
	ueberpruefe_auf_ende(SpielfeldEnde3,Spielfeld).

% ueberpruefe_auf_ende
% Wertet das Bieten aus, falls jeder Spieler geboten hat
ueberpruefe_auf_ende(SpielfeldAnfang,Spielfeld) :-
	member(bietphase([]),SpielfeldAnfang),
	beende_bietphase(SpielfeldAnfang,Spielfeld).
ueberpruefe_auf_ende(Spielfeld,Spielfeld) :-
	not(member(bietphase([]),Spielfeld)).

% beende_bietphase
% Sollte am Ende der Bietphase aufgerufen werden.
% Entfernt den Fakt bietphase/1
% und berechnet anhand der abgegebenen Gebote die neue Zugreihenfolge
% und ueberschreibt die Zugreihenfolge
beende_bietphase(SpielfeldAnfang,Spielfeld) :-
	select(bietphase(_),SpielfeldAnfang,SpielfeldAnfang2),
	findall(Gebot-Spieler,
		member(aktuelles_gebot(Spieler,Gebot),
		       SpielfeldAnfang2),
		Tupelliste),
	keysort(Tupelliste,STupelListe),
	tupel2spieler(STupelListe,Spielerliste),

	select(zugreihenfolge(_),SpielfeldAnfang2,SpielfeldEnde),
	append([zugreihenfolge(Spielerliste)],
	       SpielfeldEnde,
	       SpielfeldEnde2),
	starte_ziehphase(SpielfeldEnde2,Spielfeld).

% reset_chips_liste(+Spielerliste)
% Setzt die vorhandenen Chips fuer
% die Spieler auf den Startwert zurueck
reset_chips_liste([],Spielfeld,Spielfeld).
reset_chips_liste([H|T],SpielfeldAnfang,Spielfeld) :-
	       append([noch_vorhandener_chip(H,1),
		       noch_vorhandener_chip(H,2),
		       noch_vorhandener_chip(H,3),
		       noch_vorhandener_chip(H,4),
		       noch_vorhandener_chip(H,5)],
		      SpielfeldAnfang,
		      Spielfeld2),
	reset_chips_liste(T,Spielfeld2,Spielfeld).
