:- [ki],[initialisierung].

start(Port) :-
	free(@socket),
	starte_spielfeld([keinClient,keinClient,keinClient]),
	setze_einzel_akt,
	retractall(spieler_liste(_)),
	retractall(client(_,_)),
	new(@socket, socket(Port)),
	send(@socket, input_message, message(@prolog, message_input,
					     @receiver, @arg1)),
	send(@socket, accept_message, message(@prolog, client_verbinden,
					      @receiver, @arg1)),
	send(@socket, listen),
	assert(spieler_liste([rot,blau,gruen])).

:- dynamic spieler_liste/1,client/2.

client_verbinden(_,Receiver) :-
	spieler_liste(X),
	atomic_list_concat(X,'$',Y),
	atom_concat('$verb$',Y,Start),
	atom_concat(Start,'\n',Start2),
	send(Receiver,format, Start2).

message_input(Receiver,Data) :-
	get(Data,value,Atom),
	writeln(Atom),
	spielzug(Receiver,Atom).

spielzug(Receiver,Atom) :-
	spielfeld(X),
	not(client(_,Receiver)),
	term_to_atom(anmeldung(Name,Spieler),Atom),
	Spieler \= gast,
	not(client(Spieler,Receiver)),
	spieler_liste(Liste),
        select(spieler(_,Spieler,Burgen),X,Y),
	select(Spieler,Liste,Liste2),
	writeln(Spieler),
	atom_concat('$start$',Spieler,Start),
	send(Receiver,format, Start),
	assert(client(Spieler,Receiver)),
	update_data([spieler(Name,Spieler,Burgen)|Y]),
	writeln('data'),
	retract(spieler_liste(Liste)),
	assert(spieler_liste(Liste2)).

spielzug(Receiver,Atom) :-
	not(client(_,Receiver)),
	term_to_atom(anmeldung(_,Spieler),Atom),
	Spieler \= gast,
	client(Spieler,_),
	client_verbinden(_,Receiver).

spielzug(Receiver,Atom) :-
	spielfeld(X),
	not(client(_,Receiver)),
	term_to_atom(anmeldung(_,gast),Atom),
	assert(client(gast,Receiver)),
	writeln('gast'),
	send(Receiver,format, '$start$gast'),
	writeln(X),
	update_data(X),
	writeln('data').

spielzug(Receiver,Atom) :-
	client(_,Receiver),
	term_to_atom(nachricht(_),Atom),
	forall(client(Farbe,Client),
	       (  write('Nachricht an Klient '),
		  writeln(Farbe),
		  send(Client, format, Atom))).

spielzug(Receiver,Atom) :-
	client(_,Receiver),
	Atom = 'schluss\n',
	retract(client(Spieler,Receiver)),
	writeln('schluss!!!!'),
	spielfeld(Spiel),
	(Spieler = gast;
	Spieler \= gast->(retract(spieler_liste(X)),
			  assert(spieler_liste([Spieler|X])),
			  select(spieler(_,Spieler,Burgen),Spiel,Spiel2),
			  update_data([spieler('keinClient',Spieler,Burgen)|Spiel2]))).

spielzug(Receiver,Atom) :-
	client(Spieler,Receiver),
	Atom \= 'schluss\n',
	Atom \= 'nachricht(_)\n',
	aktueller_spieler(Spieler),
	atom_to_term(Atom,Spielzug,_),
	writeln(Atom),
	spielzuga(Receiver,Spielzug).

spielzug(Receiver,Atom) :-
	client(Spieler,Receiver),
	Atom \= 'schluss\n',
	Atom \= 'nachricht(_)\n',
	aktueller_spieler(AktSpieler),
	AktSpieler \= Spieler,
	send(Receiver, format, '$fail$nicht_aktueller_spieler\n').

spielzuga(Receiver,Spielzug) :-
	Spielzug = gebot_eingeben(Gebot),
	spielfeld(X),
	(gebot_eingeben(Gebot,X,Y)->update_data(Y)
	;send(Receiver, format, '$fail$falscher_spielzug\n')),
	writeln('ende').

spielzuga(Receiver,Spielzug) :-
	Spielzug = ritter_auf_feld_legen(Farbe,Feld),
	spielfeld(X),
	(ritter_auf_feld_legen(Farbe,Feld,X,Y)->update_data(Y)
	;send(Receiver, format, '$fale$falscher_spielzug\n')),
	writeln('ende').

spielzuga(Receiver,Spielzug) :-
	Spielzug = kaiser_bewegen(Schritte),
	spielfeld(X),
	(kaiser_bewegen(Schritte,X,Y)->
	 beende_spielzug(Y);
	 send(Receiver,format,'@fale@falscher_spielzug\n')),
	writeln('ende').

spielzuga(Receiver,Spielzug) :-
	Spielzug \= gebot_eingeben(_),
	Spielzug \= ritter_auf_feld_legen(_,_),
	Spielzug \= kaiser_bewegen(_),
	send(Receiver, format, '$fale$kein_spielzug\n'),
	writeln('kein spielzug').

beende_spielzug(Spielfeld) :-
	burgen_tausch(Spielfeld,X),
	drei_ritter_nachziehen(X,Y),
	zieh_ende(Y,Z),
	update_data(Z).

update_data(Spielfeld) :-
	retract(spielfeld(_)),
	assert(spielfeld(Spielfeld)),
	aktueller_spieler(Spieler,Spielfeld),
	(member(phase(X),Spielfeld) -> zphasen(X,Spielzug);
	member(bietphase([Spieler|_]),Spielfeld) -> Spielzug = 'bieten'),
	writeln('*****'),
	writeln(Spieler),
	writeln(Spielzug),
	writeln('*****'),
	term_to_atom(spielfeld(Spielfeld),Atom),
	atom_concat(Atom,'\n',FeldN),
	atom_concat('$up$',FeldN,Up),
	atom_concat('$go$',Spielzug,GoZwischen),
	atom_concat(GoZwischen,'\n',Go),
	atom_concat('$go$',Spieler,GoSpieler),
	atom_concat(GoSpieler,'_ist_dran',Go2Zwischen),
	atom_concat(Go2Zwischen,'\n',Go2),
	forall(client(Farbe,Receiver),
	       (  write('Update Klient '),
		  writeln(Farbe),
		  send(Receiver, format, Up),
		  (Farbe=Spieler->send(Receiver,format,Go);
		  Farbe\=Spieler->send(Receiver,format,Go2)))).

spielfeld_to_atom(Atom) :-
	findall(Assert,(
		       (spieler(A,B,C),
			term_to_assert(spieler(A,B,C),Assert,','));
		       (reserve_ritter(D,E,F,G,H,I),
			term_to_assert(reserve_ritter(D,E,F,G,H,I),Assert,','));
		       (ritter_gesetzt(J,K,L,M,N,O),
			term_to_assert(ritter_gesetzt(J,K,L,M,N,O),Assert,','));
		       (noch_vorhandener_chip(P,Q),
			term_to_assert(noch_vorhandener_chip(P,Q),Assert,','));
		       (aktuelles_gebot(R,S),
			term_to_assert(aktuelles_gebot(R,S),Assert,','));
		       (mehrheit(T,U),
			term_to_assert(mehrheit(T,U),Assert,','));
		       (feld(V,W,X),
			term_to_assert(feld(V,W,X),Assert,','));
		       (burgen(Y,Z,A),
			term_to_assert(burgen(Y,Z,A),Assert,','));
		       (ritter_auf_feld(B,C,D,E,F,G),
			term_to_assert(ritter_auf_feld(B,C,D,E,F,G),Assert,','));
		       (kaiser(H),
			term_to_assert(kaiser(H),Assert,','));
		       (zugreihenfolge(I),
			term_to_assert(zugreihenfolge(I),Assert,','));
		       (bietphase(J),
			term_to_assert(bietphase(J),Assert,','));
		       (ziehphase(K),
			term_to_assert(ziehphase(K),Assert,','));
		       (phase(L),
			term_to_assert(phase(L),Assert,',')))
		       ,SpielerListe),
	atomic_list_concat(SpielerListe,AssertAtom),
	(gewinner(M)->
	(term_to_assert(gewinner(M),Assert,'.'),atomic_concat(AssertAtom,Assert,Atom));
	 not(gewinner(M))->(atom_concat(X,',',AssertAtom),atomic_concat(X,'.',Atom))).

zphasen(X,ritter_legen) :- X>0.
zphasen(0,kaiser_bewegen).

term_to_assert(Term,AssertAtom,End) :-
	term_to_atom(Term,Atom),
	atom_concat('assert(',Atom,Assert),
	atom_concat(Assert,')',Assert2),
	atom_concat(Assert2,End,AssertAtom).

beenden :-
	forall(client(_,Receiver),
	       send(Receiver, format, '\n')),
	writeln('ENDE').


