:- [util].

:- dynamic(raf/2).
:- dynamic(masse_display/2).

raf(1,0).
raf(2,0).
raf(3,0).
raf(4,0).
raf(5,0).
raf(6,0).
raf(7,0).
raf(8,0).
raf(9,0).
raf(10,0).
raf(11,0).
raf(12,0).
raf(13,0).
raf(14,0).
raf(15,0).

:- dynamic(clipboard/1).

masse_display(804,708).

hoehe_zeile(YZ) :- masse_display(_,Y), YZ is Y / 12.
masse_ritter(MR) :- masse_display(_,Y), MR is Y / 27.
masse_spieler(MS) :-masse_display(_,Y), MS is Y / 16.
masse_chip(MC) :-masse_display(_,Y), MC is Y / 16.
masse_gap(MG) :- masse_display(X,_), MG is X / 100.
masse_ygap(3).
masse_burg(MB) :- masse_display(_,Y), MB is Y / 20.
masse_kaiser(K) :- masse_display(_,Y), K is Y / 20.
masse_ritter_feld(MRF) :- masse_display(_,Y), MRF is Y / 30.
masse_felder(FX,FY) :- masse_display(X,Y), FX is X/7, FY is Y/10.
mitte_spielfeld(MX,MY) :- masse_display(X,Y), hoehe_zeile(Z),
	                  MY is (Y-3.25*Z)/2,
			  MX is X / 2 -5.
delta_feld(C) :- masse_display(_,Y) , C is Y/3.3.
ellipse(Q) :- masse_display(X,Y), Q is X/Y + 0.4.

erzeuge_window(X,Y) :-
	free_all,
        init_window(X,Y),
        aktualisiere_gui.

:- dynamic client_spieler/1.

init_window(X,Y) :-
	free(@back_image),
	free(@layer),
	new(@fenster,picture('',size(X,Y))),
	send(@fenster, horizontal_scrollbar, @off),
	send(@fenster, vertical_scrollbar, @off),
	new(@back_image, figure),
	new(@layer, bitmap('image/background.gif')),
	send(@back_image, display, bitmap('image/background_hell.gif')),
	send(@back_image, clip_area, area(0,0,X,Y)),
	send(@fenster, display, @back_image),
	init_spieler(3),
	init_spielfeld.

resize_neu :-
	free_all_but_fenster,
	masse_display(X,Y),
	X1 is X-10, Y1 is Y -10,
	send(@back_image, clip_area, area(0,0,X1,Y1)),
	send(@fenster, size, size(X,Y)),
	init_spieler(3),
	init_spielfeld,
	aktualisiere_gui.

init_spieler(0).
init_spieler(N) :-
	N > 0,
	concat(spielerpan,N,PanelID),
	new(@PanelID, device),

	concat(spielericon,N,SpielerIconID),
	masse_spieler(S),
        send(@PanelID, display, new(@SpielerIconID, box(S,S))),

	concat(hof,N,HofID),
	new(@HofID, device),

	farben(Liste),
	nth1(N,Liste,FarbeD),

	concat(PanelID, b, SpielerBurgID),
	atomic_list_concat(['image/burg_',FarbeD,'.gif'],ImgFile),
        new(Burg, image(ImgFile)),
        get(Burg,scale,size(S,S),SpielerBurg),
	new(@SpielerBurgID, bitmap(SpielerBurg)),
	send(@PanelID, display, @SpielerBurgID),

	send(@HofID,
		recogniser,
		click_gesture(left,
			      '',
			      single,
			      message(@prolog, ritter_innen_hof))),

	masse_display(X,Y),
	HofX is X /16.2,
	ReserveX is X / 3.1,
	ChipsX is X / 1.6,
	send(@HofID, display, text(''), point(0,0)),
	        init_hof(5,HofID),
	send(@PanelID, display, @HofID, point(HofX,0)),

	concat(reserve,N,ReserveID),
	new(@ReserveID, device),
	send(@ReserveID, display, text(''), point(0,0)),
	init_res(5,ReserveID),
	send(@PanelID, display, @ReserveID, point(ReserveX,0)),

	concat(chip,N,ChipID),
	new(@ChipID, device),
	init_chips(5,ChipID),
	send(@PanelID, display, @ChipID, point(ChipsX,0)),

	hoehe_zeile(H),
	masse_gap(Gap),
	YZeile is Y -4*H + N*H -10,
        send(@fenster, display, @PanelID, point(Gap,YZeile)),

	N1 is N-1,
	init_spieler(N1).

init_hof(0,_).
init_hof(N,HofID) :-
	       N \== 0,
	       concat(HofID,N,HofFeldID),
	       masse_ritter(R),
	       masse_gap(Gap),

	       Breite is R + Gap,
	       X is N*Breite,

	       send(@HofID, display, new(@HofFeldID, box(R,R)), point(X,0)),

	       farben(Liste),
	       nth1(N,Liste,FarbeD),
	       dt2eng(FarbeD,Farbe),
	       send(@HofFeldID, fill_pattern, colour(Farbe)),

	       concat(HofFeldID, t ,HofFeldTextID),
	       TextX is X + Gap,
	       TextY is R + Gap,
	       send(@HofID, display,
                       new(@HofFeldTextID, text('0')), point(TextX, TextY)),

	       N1 is N-1,
	       init_hof(N1, HofID).

init_res(0,_).
init_res(N,HofID) :-
	       N \== 0,
	       concat(HofID,N,HofFeldID),
	       masse_ritter(R),
	       masse_gap(Gap),

	       Breite is R + Gap,

	       X is N*Breite,

	       masse_ritter(R),

	       farben(Liste),
	       nth1(N,Liste,FarbeD),

	       concat(HofFeldID,r,ReserveRitterID),
	       atomic_list_concat(['image/ritter_',FarbeD,'.gif'],ImgFile),
	       new(Ritter, image(ImgFile)),
	       get(Ritter,scale,size(R,R),Ritterskaliert),
	       new(@ReserveRitterID,bitmap(Ritterskaliert)),

	       send(@HofID, display, @ReserveRitterID, point(X,0)),
	       send(@HofID, display, new(@HofFeldID, box(R,R)), point(X,0)),

	       send(@ReserveRitterID,
		    recogniser,
		    click_gesture(left,
				  '',
				  single,
				  message(@prolog,
					  select_reserve,HofID,FarbeD))),

	       concat(HofFeldID, t ,HofFeldTextID),

	       TextX is X + Gap,
	       TextY is R + Gap,

	       send(@HofID, display,
                       new(@HofFeldTextID, text('0')), point(TextX, TextY)),

	       N1 is N-1,
	       init_res(N1, HofID).

select_reserve(HofID,FarbeD) :-
	clipboard(FarbeD),

	retract(clipboard(FarbeD)),
	aktualisiere_markierung(HofID).

select_reserve(HofID,FarbeD) :-
	not(clipboard(FarbeD)),

	ziehphase(_),
	phase(X),
	X > 0,

	concat(reserve,Z,HofID),
	atom_number(Z,ZN),
	aktuelle_zeile(ZN),

        retractall(clipboard(_)),
	assert(clipboard(FarbeD)),
	aktualisiere_markierung(HofID).

ritter_innen_hof :-
	writeln('ritter_innen_hof'),
	(phase(1)->retract(clipboard(FarbeD));clipboard(FarbeD)),
	gui_ritter_auf_feld(FarbeD,hof).

feld_aktion(FeldNr) :-
	writeln('feld_aktion'),
	phase(X),
	X > 0,
	(phase(1)->retract(clipboard(FarbeD));clipboard(FarbeD)),
	gui_ritter_auf_feld(FarbeD,FeldNr).

feld_aktion(FeldNr) :-
	writeln('feld_aktion2'),
	phase(0),
	kaiser(Start),
	weg2schritte(Start,FeldNr,Schritte),
	gui_kaiser(Schritte),
	retractall(clipboard(_)).

bieten_aktion(Gebot,Zeile) :-
	writeln('bieten_aktion'),
	atom_number(Zeile,ZeileN),
	aktuelle_zeile(ZeileN),
	gui_gebot(Gebot).

aktualisiere_markierung(HofID) :-

	concat(reserve,Z,HofID),

	atom_number(Z,ZN),

	concat(HofID,1,HofID1),
	concat(HofID,2,HofID2),
	concat(HofID,3,HofID3),
	concat(HofID,4,HofID4),
	concat(HofID,5,HofID5),

	send(@HofID1, pen, 0),
	send(@HofID2, pen, 0),
        send(@HofID3, pen, 0),
        send(@HofID4, pen, 0),
        send(@HofID5, pen, 0),

	(clipboard(Farbe),
	 aktuelle_zeile(ZN) ->
	 (farben(Farbliste),
	  nth1(N,Farbliste,Farbe),
	  concat(HofID,N,HofIDN),
	  send(@HofIDN, pen, 2));
	  true).

aktuelle_zeile(ZN) :-
	 aktueller_spieler(S),
	 zugreihenfolge(R),
	 nth1(ZN,R,S).

init_chips(0,_).
init_chips(N,ChipID) :-
	       N \== 0,
	       concat(chip,Z,ChipID),
	       concat(ChipID,N,ChipNummerID),
	       masse_gap(Gap),
	       masse_chip(C),
	       Breite is C + Gap,
	       X is (N-1)* Breite,

	       send(@ChipID, display,
	       new(@ChipNummerID, circle(C)), point(X,0)),

	       TextGap is (C /2 - 7),
	       TextX is (X+TextGap+2),

	       concat(ChipNummerID,t,ChipNummerNummerID),
	       send(@ChipID, display,
		    new(@ChipNummerNummerID, text(N)), point(TextX,TextGap)),

	       send(@ChipNummerID,
		    recogniser,
		    click_gesture(left,
				  '',
				  single,
				  message(@prolog, bieten_aktion, N, Z))),

	       N1 is N-1,
	       init_chips(N1, ChipID).

init_spielfeld :-
	init_felder(15),
	new(@spielfeld, device),
	send(@fenster, display, @spielfeld, point(0,0)),
	masse_kaiser(MK),
	new(Kaiser, image('image/koenig.gif')),
	get(Kaiser,scale,size(MK,MK),Kaiserskaliert),
	new(@k,bitmap(Kaiserskaliert)).

init_felder(0).
init_felder(N) :-
	N \== 0,
	concat(feld,N,FeldID),
	new(@FeldID, device),
	concat(FeldID,b,FeldBoxID),

	masse_felder(MFX,MFY),
	concat(FeldID,f,FeldFigureID),
	new(@FeldFigureID, figure),
	get(@layer, copy, F),
	send(@FeldFigureID, display, F),
	send(@fenster, display, @FeldFigureID),
	send(@FeldID, display, new(@FeldBoxID, box(MFX,MFY))),

	send(@FeldID,
	     recogniser,
	     click_gesture(left,
	                   '',
	                   single,
			   message(@prolog, feld_aktion, N))),

	N1 is N - 1,
	init_felder(N1).

aktualisiere_gui :-
	aktualisiere_spieler(3),
	free_felderinhalt(15),
	aktualisiere_spielfeld(15,FL),
	Winkelkonstante is 2*pi/15,
	aktualisiere_feldposition(FL,0,Winkelkonstante),
	aktualisiere_kaiser.

aktualisiere_kaiser :-
	kaiser(F),

	concat(feld,F,FeldNr),
	masse_gap(G),
	masse_kaiser(MK),
	get(@FeldNr,width,GX),
	X is GX-G-MK,
	masse_ygap(YG),

	send(@fenster, display, @k),
	send(@FeldNr, display, @k, point(X,YG)).
aktualisiere_feldposition([],_,_).

aktualisiere_feldposition([FN|R],EN,WK) :-
	feld(FN,_,_),
	((burgen(FN,_,Burgen)->Burg=Burgen);Burg=1),

	mitte_spielfeld(MSX,MSY),
	delta_feld(C),

	Pos is EN+(Burg/2),

	Alpha is Pos*WK,

	ellipse(E),

	MFX is MSX+(C*E/sqrt(sqrt(Burg)))*sin(Alpha),
	MFY is MSY+(C/sqrt(sqrt(Burg)))*cos(Alpha),

	masse_felder(FFX,FFY),


	MFFX is sqrt(Burg)*FFX,

	MFFY is sqrt(Burg)*FFY,

	concat(feld,FN,FeldID),
	concat(FeldID,b,FeldBoxID),
	concat(FeldID,f,FeldFigureID),

	free(@FeldBoxID),
	send(@FeldID, display, new(@FeldBoxID, box(MFFX,MFFY))),

	XFX is MFX - MFFX/2,
	YFY is MFY - MFFY/2,

	aktueller_spieler(S),

	(aktuelles_gebot(S,Gebot),
	 kaiser(K),
	 moegliche_felder_d(K,Gebot,Liste),
	 member(FN,Liste) ->
	 send(@FeldBoxID, pen, 3);
	 send(@FeldBoxID, pen, 1)),

	send(@spielfeld, display, @FeldID, point(XFX,YFY)),
	ClipX is XFX , ClipY is YFY ,
	send(@FeldFigureID, clip_area, area(ClipX, ClipY, MFFX, MFFY)),
	aktualisiere_burgen(FN),
	aktualisiere_ritter_auf_feld(FN),

	EN1 is Burg+EN,

	aktualisiere_feldposition(R,EN1,WK).

aktualisiere_spieler(0).
aktualisiere_spieler(N) :-
	N \== 0,
	concat(spielericon,N,SpielerIconID),
	zugreihenfolge(Spielerliste),
	nth1(N,Spielerliste,SpielerID),
	masse_spieler(S),
	concat(spielerpan, N, SpielerPan),
	concat(SpielerPan, b, SpielerBurgID),
	atomic_list_concat(['image/burg_',SpielerID,'.gif'],ImgFile),
        new(Burg, image(ImgFile)),
        get(Burg,scale,size(S,S),SpielerBurg),
	send(@SpielerBurgID, image(SpielerBurg)),

	(aktueller_spieler(SpielerID) ->
	 send(@SpielerIconID, pen, 2);
	 send(@SpielerIconID, pen, 0)),

	concat(hof,N,HofID),
	aktualisiere_hoefe(5,HofID,SpielerID),

	concat(reserve,N,ReserveID),
	aktualisiere_reserve(5,ReserveID,SpielerID),

	concat(chip,N,ChipID),
	aktualisiere_chips(5,ChipID,SpielerID),

	N1 is N - 1,
	aktualisiere_spieler(N1).

aktualisiere_hoefe(0,_,_).
aktualisiere_hoefe(N,HofID,SpielerID) :-
	N \== 0,
	concat(HofID,N,HofFeldID),

	farben(Farben),

	nth1(N,Farben,HofFarbe),

	(mehrheit(HofFarbe,SpielerID) ->
	 send(@HofFeldID, radius, 20);
	 send(@HofFeldID, radius, 0)),

	concat(HofFeldID,t,HofFeldTextID),

	ritter_gesetzt(SpielerID,Rot,Gruen,Gelb,Blau,Pink),

	farbe(HofFarbe,Rot2,Gruen2,Gelb2,Blau2,Pink2),

	Anzahl is Rot*Rot2+Gruen*Gruen2+Gelb*Gelb2+Blau*Blau2+Pink*Pink2,

	send(@HofFeldTextID, string, Anzahl),

	N1 is N-1,
        aktualisiere_hoefe(N1, HofID,SpielerID).

aktualisiere_reserve(0,_,_).
aktualisiere_reserve(N,HofID,SpielerID) :-
	N \== 0,
	concat(HofID,N,HofFeldID),

	farben(Farben),

	nth1(N,Farben,HofFarbe),

	concat(HofFeldID,t,HofFeldTextID),

	reserve_ritter(SpielerID,Rot,Gruen,Gelb,Blau,Pink),

	farbe(HofFarbe,Rot2,Gruen2,Gelb2,Blau2,Pink2),

	Anzahl is Rot*Rot2+Gruen*Gruen2+Gelb*Gelb2+Blau*Blau2+Pink*Pink2,

	send(@HofFeldTextID, string, Anzahl),

	aktualisiere_markierung(HofID),

	N1 is N-1,
        aktualisiere_reserve(N1, HofID,SpielerID).

aktualisiere_chips(0,_,_).
aktualisiere_chips(N,ChipID,SpielerID) :-
	N \== 0,

	concat(ChipID,N,ChipNummerID),
	concat(ChipNummerID,t,ChipNummerNummerID),

	masse_chip(R),

	(noch_vorhandener_chip(SpielerID,N) ->
	 send(@ChipNummerID, diameter, R),
	 send(@ChipNummerNummerID, string, N),
	 send(@ChipNummerID, fill_pattern, colour(white));
	 (aktuelles_gebot(SpielerID,N) ->
	  send(@ChipNummerID, diameter, R),
	  send(@ChipNummerNummerID, string, N),
	  send(@ChipNummerID, fill_pattern, colour(gray));
	  send(@ChipNummerID, diameter, 0),
	  send(@ChipNummerNummerID, string, ''))),

	(not(kann_bieten(SpielerID,N)),
	 bietphase(_),
	 aktueller_spieler(SpielerID) ->
	  send(@ChipNummerID, fill_pattern, colour(red));true),

	N1 is N-1,
	aktualisiere_chips(N1,ChipID,SpielerID).

aktualisiere_spielfeld(0,[]).
aktualisiere_spielfeld(N,R) :-
	N \== 0,

	not(feld(N,_,_)),

	concat(feld,N,FeldNR),
	free(@FeldNR),
	atomic_list_concat([feld,N,f],FeldFigure),
	free(@FeldFigure),

	N1 is N-1,
	aktualisiere_spielfeld(N1,R).

aktualisiere_spielfeld(N,[N|R]) :-
	N \== 0,

	feld(N,_,_),

	N1 is N-1,
	aktualisiere_spielfeld(N1,R).

aktualisiere_burgen(FeldID) :-
	burgen(FeldID,Farbe,Anzahl),
	aktualisiere_burg(FeldID,Farbe,Anzahl).

aktualisiere_burgen(FeldID) :-
	not(burgen(FeldID,_,_)).

aktualisiere_burg(_,_,0).
aktualisiere_burg(FeldID,Farbe,N) :-
	N > 0,
	concat(feld,FeldID,FeldNummer),

	concat(FeldNummer,burg,FeldB),
	concat(FeldB,N,FeldBurgID),

	masse_burg(C),

	masse_gap(G),
	masse_ygap(YG),

	X is ((N-1)*(C-2*G)),

	atomic_list_concat(['image/burg_',Farbe,'.gif'],ImgFile),
	new(Burg, image(ImgFile)),
	get(Burg,scale,size(C,C),Burgskaliert),
	new(@FeldBurgID,bitmap(Burgskaliert)),
	Y is YG-3,
	send(@FeldNummer, display, @FeldBurgID, point(X,Y)),

	N1 is N-1,
	aktualisiere_burg(FeldID,Farbe,N1).

aktualisiere_ritter_auf_feld(FeldID) :-
	ritter_auf_feld(FeldID,Ro,Gr,Ge,Bl,Pi),

	aktualisiere_ritter(FeldID,rot,Ro,0),

	aktualisiere_ritter(FeldID,gruen,Gr,Ro),

	RoGr is Ro+Gr,

	aktualisiere_ritter(FeldID,gelb,Ge,RoGr),

	RoGrGe is RoGr+Ge,

        aktualisiere_ritter(FeldID,blau,Bl,RoGrGe),

	RoGrGeBl is RoGrGe+Bl,

        aktualisiere_ritter(FeldID,pink,Pi,RoGrGeBl),

	Anzahl is Ro+Gr+Ge+Bl+Pi,
	retractall(raf(FeldID,_)),
	assert(raf(FeldID,Anzahl)).

aktualisiere_ritter(_,_,0,_).
aktualisiere_ritter(FeldID, Farbe, N, Anzahl) :-
	N\==0,
	concat(feld,FeldID,FeldNr),
	concat(FeldNr,ritter,FeldNrR),

	RNR is Anzahl + N,

	concat(FeldNrR, RNR, FeldRitterNummer),

	masse_ritter_feld(C),
	masse_gap(G),
	X is ((Anzahl+N-1)*0.7*C+G),

	masse_burg(MB),
	masse_ygap(YG),

	Y is (2*YG + MB),

	atomic_list_concat(['image/ritter_',Farbe,'.gif'],ImgFile),
	new(Ritter, image(ImgFile)),
	get(Ritter,scale,size(C,C),Ritterskaliert),
	new(@FeldRitterNummer,bitmap(Ritterskaliert)),

	send(@FeldNr, display, @FeldRitterNummer, point(X,Y)),

	N1 is N-1,

	aktualisiere_ritter(FeldID, Farbe, N1, Anzahl).

free_felderinhalt(0).
free_felderinhalt(N) :-
	N \== 0,
	free_burgen(15,N),
	raf(N,AnzahlRitter),
	free_ritter(AnzahlRitter,N),
	N1 is N-1,
	free_felderinhalt(N1).

free_ritter(0,_).
free_ritter(N,FeldID) :-
	N \== 0,

	concat(feld,FeldID,FeldNr),
	concat(FeldNr,ritter,FeldNrR),
	concat(FeldNrR,N,FeldNummerRitterID),

	free(@FeldNummerRitterID),

	N1 is N - 1,
	free_ritter(N1,FeldID).

free_burgen(0,_).
free_burgen(N,FeldID) :-
	N \== 0,

	concat(feld,FeldID,FeldNr),
	concat(FeldNr,burg,FeldNrb),
	concat(FeldNrb,N,FeldBurgID),

	free(@FeldBurgID),

	N1 is N-1,
	free_burgen(N1,FeldID).

free_all :- free(@fenster),
	    free(@zugButton),
	    free(@speichernButton),
	    free(@ladenButton),
	    free(@quitButton),
	    free_all_but_fenster.

free_all_but_fenster :-
	        free(@spielerpan1),
		free(@spielerpan2),
		free(@spielerpan3),

		free(@spielerpan1b),
		free(@spielerpan2b),
		free(@spielerpan3b),

		free(@spielericon1),
		free(@spielericon2),
		free(@spielericon3),

		free(@hof1),
		free(@hof11),
                free(@hof12),
                free(@hof13),
                free(@hof14),
                free(@hof15),

		free(@hof11t),
                free(@hof12t),
                free(@hof13t),
                free(@hof14t),
                free(@hof15t),

		free(@hof2),
		free(@hof21),
                free(@hof22),
                free(@hof23),
                free(@hof24),
                free(@hof25),

		free(@hof21t),
                free(@hof22t),
                free(@hof23t),
                free(@hof24t),
                free(@hof25t),

		free(@hof3),
		free(@hof31),
                free(@hof32),
                free(@hof33),
                free(@hof34),
                free(@hof35),

		free(@hof31t),
                free(@hof32t),
                free(@hof33t),
                free(@hof34t),
                free(@hof35t),

		free(@reserve1),
		free(@reserve11),
                free(@reserve12),
                free(@reserve13),
                free(@reserve14),
                free(@reserve15),

		free(@reserve11t),
                free(@reserve12t),
                free(@reserve13t),
                free(@reserve14t),
                free(@reserve15t),

		free(@reserve11r),
                free(@reserve12r),
                free(@reserve13r),
                free(@reserve14r),
                free(@reserve15r),

		free(@reserve2),
		free(@reserve21),
                free(@reserve22),
                free(@reserve23),
                free(@reserve24),
                free(@reserve25),

		free(@reserve21t),
                free(@reserve22t),
                free(@reserve23t),
                free(@reserve24t),
                free(@reserve25t),

		free(@reserve21r),
                free(@reserve22r),
                free(@reserve23r),
                free(@reserve24r),
                free(@reserve25r),

		free(@reserve3),
		free(@reserve31),
                free(@reserve32),
                free(@reserve33),
                free(@reserve34),
                free(@reserve35),

		free(@reserve31t),
                free(@reserve32t),
                free(@reserve33t),
                free(@reserve34t),
                free(@reserve35t),

		free(@reserve31r),
                free(@reserve32r),
                free(@reserve33r),
                free(@reserve34r),
                free(@reserve35r),

		free(@chip1),
		free(@chip11),
                free(@chip12),
                free(@chip13),
                free(@chip14),
                free(@chip15),

		free(@chip11t),
                free(@chip12t),
                free(@chip13t),
                free(@chip14t),
                free(@chip15t),

		free(@chip2),
		free(@chip21),
                free(@chip22),
                free(@chip23),
                free(@chip24),
                free(@chip25),

		free(@chip21t),
                free(@chip22t),
                free(@chip23t),
                free(@chip24t),
                free(@chip25t),

		free(@chip3),
		free(@chip31),
                free(@chip32),
                free(@chip33),
                free(@chip34),
                free(@chip35),

		free(@chip31t),
                free(@chip32t),
                free(@chip33t),
                free(@chip34t),
                free(@chip35t),

		free(@spielfeld),

		free(@feld1),
		free(@feld2),
		free(@feld3),
		free(@feld4),
		free(@feld5),
		free(@feld6),
		free(@feld7),
		free(@feld8),
		free(@feld9),
		free(@feld10),
		free(@feld11),
		free(@feld12),
		free(@feld13),
		free(@feld14),
		free(@feld15),

		free(@feld1b),
		free(@feld2b),
		free(@feld3b),
		free(@feld4b),
		free(@feld5b),
		free(@feld6b),
		free(@feld7b),
		free(@feld8b),
		free(@feld9b),
		free(@feld10b),
		free(@feld11b),
		free(@feld12b),
		free(@feld13b),
		free(@feld14b),
		free(@feld15b),

		free(@feld1f),
		free(@feld2f),
		free(@feld3f),
		free(@feld4f),
		free(@feld5f),
		free(@feld6f),
		free(@feld7f),
		free(@feld8f),
		free(@feld9f),
		free(@feld10f),
		free(@feld11f),
		free(@feld12f),
		free(@feld13f),
		free(@feld14f),
		free(@feld15f),


		free(@k).
